
#ifndef _FTP_SERVER_H_
#define _FTP_SERVER_H_


/* Bear Transfer Protocol (BTP), a TCP/IP socket based file 
   transfer utility

  The author of this software is Ian Kaplan
  www.bearcave.com
  iank@bearcave.com

  Copyright (c) Ian Kaplan, 1999

  See "copyright" file for allowed use.

*/


/*
 * ftp_server
 *
 */
class ftp_server {
private:
  netfile file_obj;
  netio netio_obj;
  iowrap iofunc;

private:
  const char *get_dest_name(int sockfd, char *file_name, const int name_size,
			    const char *prog_name );
  const char *get_src_name(int sockfd, char *file_name, const int name_size,
			   const char *prog_name );
  void change_cwd( int sockfd );
  void send_cwd( int sockfd );
  void put_dir_name( int sockfd, char *name, io_block &blk, COMMANDS com );
  void send_dir_names( int sockfd );

public:
  ftp_server() {};
  void process_commands( int sockfd, const char *prog_name );
}; // ftp_server

#endif
