
#ifndef _INTERVAL_H_
#define _INTERVAL_H_


/* Bear Transfer Protocol (BTP), a TCP/IP socket based file 
   transfer utility

  The author of this software is Ian Kaplan
  www.bearcave.com
  iank@bearcave.com

  Copyright (c) Ian Kaplan, 1999

  See "copyright" file for allowed use.

*/


/*

   Include <string.h>       -- for memset
           <sys/types.h>    -- for ftime
           <sys/timeb.h>    -- for ftime

   before including this file.

 */

typedef struct {
  int sec;      // seconds
  int millisec; // milliseconds
} elapsed_time;

/*
 *  time_interval
 *
    Support measuring a time interval (on both UNIX and NT)
 */
class time_interval {
private:
  struct timeb time_start, time_end;

public:
  time_interval()
  {
    memset( (void *)&time_start, 0, sizeof( time_start ) );
    memset( (void *)&time_end, 0, sizeof( time_end ) );
  }
  void start_time()
  {
    ftime( &time_start );
  }
  void end_time()
  {
    ftime( &time_end );
  }
  elapsed_time get_elapsed()
  {
    elapsed_time delta_t;

    /****
    printf("time_end.time = %u, time_start.time = %u\n",
	   (int)time_end.time, (int)time_start.time );
    printf("time_end.millitm = %u, time_start.millitm = %u\n",
	   (int)time_end.millitm, (int)time_start.millitm );
    *****/

    delta_t.sec = (int)time_end.time - (int)time_start.time;
    delta_t.millisec = (int)time_end.millitm - (int)time_start.millitm;

    return delta_t;
  }
};


#endif
