
#ifndef _NETFILE_H_
#define _NETFILE_H_


/* Bear Transfer Protocol (BTP), a TCP/IP socket based file 
   transfer utility

  The author of this software is Ian Kaplan
  www.bearcave.com
  iank@bearcave.com

  Copyright (c) Ian Kaplan, 1999

  See "copyright" file for allowed use.

*/


typedef enum { select_bad_rslt = 0,
	       select_ok_to_write = 1,
	       select_write_timeout = 2,
	       select_write_error = 3
} SELECT_RSLT;

class netfile : private netio {
private:
  COMMANDS last_command;
  Boolean debug;

private:
  SELECT_RSLT SelectWrite( const int sockfd, const char *prog_name );
  void hex_dump_word( unsigned int word );
  void hex_dump( io_block &blk );

public:
  netfile() 
  {
    last_command = bad_command;
    debug = FALSE;
  }
  COMMANDS get_io_block( int sockfd, io_block &blk, const char *prog_name);

  int get_file( int sockfd, FILE *dest_fp, 
		 const char *file_name, const char *prog_name );
  void put_file( int sockfd, FILE *src_fp, const char *srcname,
		      const char *prog_name );
  void set_debug_mode()   
  { 
    debug = TRUE; 
    set_debug();  // set debug in netio
  }
  void clear_debug_mode() 
  { 
    debug = FALSE; 
    clear_debug(); // unset debug in netio
  }
}; // netfile

#endif
