
/* 
  The author of this software is Ian Kaplan
  www.bearcave.com
  iank@bearcave.com

  Copyright (c) Ian Kaplan, 1999

  See "copyright" file for allowed use.

*/


#include "netinc.h"
#include "neterr.h"
#include "commands.h"
#include "iowrap.h"
#include "netio.h"
#include "netstr.h"


/*
 * get_str
 *
 */
char *
netstr::get_str( int fd, char *str, unsigned int len )
{
  char buf[ DATA_BUF_SIZE ];
  int amt_read;
  int i, copy_len;
  char *pRetPtr = NULL;

  amt_read = read_block(fd, buf, sizeof( buf ));
  if (amt_read < len-1)
    copy_len = amt_read;
  else
    copy_len = len-1;

  for (i = 0; i < copy_len; i++) {
    str[i] = buf[i];
  }
  str[i] = '\0';

  if (i > 0)
    pRetPtr = str;

  return pRetPtr;
} // get_str



int
netstr::get_char(int fd, char *pCh )
{
  int rslt;

  if (read_cnt <= 0) {
    read_cnt = read_block( fd, read_buf, sizeof(read_buf) );
    read_ptr = read_buf;
  }

  *pCh = '\0';
  if (read_cnt > 0) {
    rslt = 1;  // read OK
    read_cnt--;
    *pCh = *read_ptr++;
  }
  else if (read_cnt < 0)
    rslt = -1;  // error 
  else
    rslt = 0;   // End of file

  return( rslt );
} // get_char



int
netstr::readline(int fd, void *vptr, size_t maxlen)
{
  int  n, rc;
  char c, *ptr;

  ptr = (char *)vptr;
  for (n = 1; n < maxlen; n++) {
    if ( (rc = get_char(fd, &c)) == 1) {
      *ptr++ = c;
      if (c == '\n')
	break;	/* newline is stored, like fgets() */
    } else if (rc == 0) {
      if (n == 1)
	return(0);	/* EOF, no data read */
      else
	break;		/* EOF, some data was read */
    } else
      return(-1);		/* error, errno set by read() */
  }

  *ptr = 0;	/* null terminate like fgets() */
  return(n);
}
/* end readline */



int
netstr::Readline(int fd, void *ptr, size_t maxlen)
{
  size_t n;

  if ( (n = readline(fd, ptr, maxlen)) < 0)
    Error("readline error");
  return(n);
} // Readline
