
#ifndef _STRHEAP_H_
#define _STRHEAP_H_


/* Bear Transfer Protocol (BTP), a TCP/IP socket based file 
   transfer utility

  The author of this software is Ian Kaplan
  www.bearcave.com
  iank@bearcave.com

  Copyright (c) Ian Kaplan, 1999

  See "copyright" file for allowed use.

*/


/*
 * string_heap
 *

   The string_heap class will allocate strings and
   keep track of the pointers for later deallocation.
 
 */
class string_heap {
private:
  LIST <char *> strings;

private:
  void free_strings(void);

public:
  char *alloc_string( const char *str );
  ~string_heap()
  {
    free_strings();
    strings.dealloc();  // deallocate the list
  }

}; // string_heap

#endif
